
/**
 * An implementation of the Gibbs Sampling Stochastic Simulation method for estimating Bayesian Network probabilities with/without evidence.
 * <b>You should only modify the simulate method.</b>
 * Algorithm from Section 4.4.3 of Pearl, Judea. "Probabilistic Reasoning in Intelligent Systems"
 */

public class BNGibbsSampler {
	/** iteration frequency of progress reports */
	public static int reportFrequency = 200000;
	/** total iterations; each non-evidence variable is updated in each iteration */
	public static int iterations = 1000000;

	/**
	 * Initialize parameters, parse input, display BN information, and perform Gibbs sampling. <b>You should not modify this method</b>
	 * @param args an array of command-line arguments
	 * @throws ParseException standard input does not match grammar for Bayesian network specification. (See assignment documentation for BNF grammar.)
	 */
	public static void main(java.lang.String[] args) throws ParseException {
		// Initialize iterations and update frequency
		if (args.length > 0) {
			iterations = Integer.parseInt(args[0]);
			reportFrequency = (args.length > 1) ? Integer.parseInt(args[1]) : iterations;
		}

		// Read in belief net specification from System.in
		new BNParse(System.in).parseInput();
		BNNode.printBN();

		// Do stochastic simulation.
		simulate();
	}

	/**
	 * Perform Stochastic Simulation as described in Section 4.4.3 of Pearl, Judea. "Probabilistic Reasoning in Intelligent Systems".
	 * The enclosed file pearl.out shows the output format given the input:
	 *   java BNGibbsSampler 1000000 200000 &lt; sample.in &gt; sample.out
	 * <b>This is the only method you should modify.</b>
	 */
	public static void simulate() {

		// ***INSERT YOUR CODE HERE***
		// My commented implementation was about 60 lines.

	}
}


